# kdeui Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KJanusWidget Class Reference

Provides a number of ready to use layouts (faces). Easy to use widget with many layouts. More...

`#include <kjanuswidget.h>`

Inheritance diagram for KJanusWidget:

[legend]
Collaboration diagram for KJanusWidget:

[legend]
List of all members.

## Public Types

enum | Face { TreeList = 0, Tabbed, Plain, Swallow, IconList }

## Public Slots

virtual void | setFocus ()
| Give the keyboard input focus to the widget.

## Signals

void | aboutToShowPage (QWidget *page)

## Public Member Functions

| KJanusWidget (QWidget *parent=0, const char *name=0, int face=Plain)
| Constructor where you specify the face.
| ~KJanusWidget ()
| Destructor.
virtual bool | showPage (int index)
| Raises the page which was added by addPage().
virtual int | activePageIndex () const
| Returns the index of the page that are currently displayed.
virtual bool | isValid () const
| Use this to verify that no memory allocation failed.
virtual int | face () const
| Returns the face type.
virtual QSize | minimumSizeHint () const
| Returns the minimum size that must be made available for the widget so that UIs can be displayed properly.
virtual QSize | sizeHint () const
| Returns the recommended size for the widget in order to be displayed properly.
virtual QFrame * | plainPage ()
| Returns the empty widget that is available in Plain mode.
virtual QFrame * | addPage (const QString &item, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
| Add a new page when the class is used in TreeList, IconList or Tabbed mode.
virtual QFrame * | addPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
| This is like addPage just above, with the difference that the first element is a list of strings.
virtual QVBox * | addVBoxPage (const QString &item, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
| Add a new page when the class is used in TreeList, IconList or Tabbed mode.
virtual QVBox * | addVBoxPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
| This is like addVBoxPage just above, with the difference that the first element is a list of strings.
virtual QHBox * | addHBoxPage (const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
| Add a new page when the class is used in TreeList, IconList or Tabbed mode.
virtual QHBox * | addHBoxPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
| This is like addHBoxPage just above, with the difference that the first element is a list of strings.
virtual QGrid * | addGridPage (int n, Orientation dir, const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
| Add a new page when the class is used in either TreeList or Tabbed mode.
virtual QGrid * | addGridPage (int n, Orientation dir, const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
| This is like addGridPage just above, with the difference that the first element is a list of strings.
void | removePage (QWidget *page)
| Removes a page created with addPage, addVBoxPage, addHBoxPage or addGridPage. If the page has already been deleted or has already been removed, nothing happens. The widget itself is not deleted.
virtual int | pageIndex (QWidget *widget) const
| Returns the index of a page created with addPage , addVBoxPage , addHBoxPage or addGridPage .
virtual bool | setSwallowedWidget (QWidget *widget)
| Defines the widget to be swallowed.
virtual void | setTreeListAutoResize (bool state)
| This function has only effect in TreeList mode.
virtual void | setShowIconsInTreeList (bool state)
| This function has only effect in TreeList mode.
virtual void | setRootIsDecorated (bool state)
| This function has only effect in TreeList mode.
virtual void | setIconListAllVisible (bool state)
| This function has only effect in IconList mode.
virtual void | setFolderIcon (const QStringList &path, const QPixmap &pixmap)
| Sets the icon used in TreeList Mode for the given path.

## Protected Member Functions

virtual void | showEvent (QShowEvent *)
| Reimplemented to handle the splitter width when the the face is TreeList.
virtual bool | eventFilter (QObject *o, QEvent *e)
| This function is used internally when in IconList mode.
bool | showPage (QWidget *w)
void | addPageWidget (QFrame *page, const QStringList &items, const QString &header, const QPixmap &pixmap)
void | InsertTreeListItem (const QStringList &items, const QPixmap &pixmap, QFrame *page)
QWidget * | FindParent ()
virtual void | virtual_hook (int id, void *data)

## Detailed Description

Provides a number of ready to use layouts (faces). Easy to use widget with many layouts.

It is used as an internal widget in KDialogBase, but can also used as a widget of its own.

It provides TreeList, IconList, Tabbed, Plain and Swallow layouts.

The TreeList face provides a list in the left area and pages in the right. The area are separated by a movable splitter. The style is somewhat similar to the layout in the Control Center. A page is raised by selecting the corresponding tree list item.

The IconList face provides an icon list in the left area and pages in the right. For each entry the Icon is on top with the text below. The style is somewhat similar to the layout of the Eudora configuation dialog box. A page is raised by selecting the corresponding icon list item. The preferred icon size is 32x32 pixels.

The Tabbed face is a common tabbed widget. The procedure for creating a page is similar for creating a TreeList. This has the advantage that if your widget contain too many pages it is trivial to convert it into a TreeList. Just change the face in the KJanusWidget constructor to KJanusWidget::TreeList and you have a tree list layout instead.

The Plain face provides an empty widget (QFrame) where you can place your widgets. The KJanusWidget makes no assumptions regarding the contents so you are free to add whatever you want.

The Swallow face is provided in order to simplify the usage of existing widgets and to allow changing the visible widget. You specify the widget to be displayed by setSwallowedWidget(). Your widget will be reparented inside the widget. You can specify a Null (0) widget. A empty space is then displayed.

For all modes it is important that you specify the QWidget::minimumSize() on the page, plain widget or the swallowed widget. If you use a QLayout on the page, plain widget or the swallowed widget this will be taken care of automatically. The size is used when the KJanusWidget determines its own minimum size. You get the minimum size by using the minimumSizeHint() or sizeHint() methods.

Pages that have been added in TreeList, IconList or Tabbed mode can be removed by simply deleting the page.

Author:
  Espen Sand (espen@kde.org)

Definition at line 89 of file kjanuswidget.h.

## Constructor & Destructor Documentation

KJanusWidget::KJanusWidget | ( | QWidget * | parent = 0,
|  | const char * | name = 0,
|  | int | face = Plain
| ) |

Constructor where you specify the face.

Parameters:

  parent | Parent of the widget.
  name | Widget name.
  int | face The kind of dialog, Use TreeList, Tabbed, Plain or Swallow.

Definition at line 84 of file kjanuswidget.cpp.

References KListView::addColumn(), QString::fromLatin1(), QListView::header(), KDialog::marginHint(), KStdAccel::name(), QWidget::QWidget(), QFont::setBold(), QLabel::setFont(), QFrame::setFrameStyle(), QTabWidget::setMargin(), QListView::setRootIsDecorated(), KListView::setSorting(), setSwallowedWidget(), and KDialog::spacingHint().

KJanusWidget::~KJanusWidget | ( |  | ) |

| Destructor. Definition at line 191 of file kjanuswidget.cpp.

## Member Function Documentation

bool KJanusWidget::showPage | ( | int | index | ) | `[virtual]`

Raises the page which was added by addPage().

Parameters:

  index | The index of the page you want to raise.

Definition at line 565 of file kjanuswidget.cpp.

Referenced by KDialogBase::showPage().

int KJanusWidget::activePageIndex | ( |  | ) | const`[virtual]`

Returns the index of the page that are currently displayed.

Returns:
  The index or -1 if the face is not Tabbed, TreeList or IconList.

Definition at line 631 of file kjanuswidget.cpp.

References QTabWidget::currentPage(), and QListView::selectedItem().

Referenced by KDialogBase::activePageIndex().

bool KJanusWidget::isValid | ( |  | ) | const`[virtual]`

Use this to verify that no memory allocation failed.

Returns:
  true if the widget was properly created.

Definition at line 197 of file kjanuswidget.cpp.

Referenced by KDialogBase::KDialogBase().

int KJanusWidget::face | ( |  | ) | const`[virtual]`

Returns the face type.

Returns:
  The face type.

Definition at line 209 of file kjanuswidget.cpp.

QSize KJanusWidget::minimumSizeHint | ( |  | ) | const`[virtual]`

Returns the minimum size that must be made available for the widget so that UIs can be displayed properly.

Returns:
  The minimum size.

Reimplemented from QWidget.

Definition at line 740 of file kjanuswidget.cpp.

References QSize::height(), QWidget::minimumSize(), QSize::rheight(), QSize::rwidth(), KDialog::spacingHint(), QWidget::style(), and QSize::width().

Referenced by sizeHint().

QSize KJanusWidget::sizeHint | ( |  | ) | const`[virtual]`

Returns the recommended size for the widget in order to be displayed properly.

Returns:
  The recommended size.

Reimplemented from QWidget.

Definition at line 799 of file kjanuswidget.cpp.

References minimumSizeHint().

QFrame * KJanusWidget::plainPage | ( |  | ) | `[virtual]`

Returns the empty widget that is available in Plain mode.

Returns:
  The widget or 0 if the face in not Plain.

Definition at line 203 of file kjanuswidget.cpp.

Referenced by KDialogBase::plainPage().

QFrame * KJanusWidget::addPage | ( | const QString & | item,
|  | const QString & | header = QString::null,
|  | const QPixmap & | pixmap = QPixmap()
| ) | `[virtual]`

Add a new page when the class is used in TreeList, IconList or Tabbed mode.

The returned widget is empty and you must add your widgets as children to this widget. In most cases you must create a layout manager and associate it with this widget as well.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Parameters:

  item | String used in the list or Tab item.
  header | A longer string used in TreeList and IconList mode to describe the contents of a page. If empty, the item string will be used instead.
  pixmap | Used in IconList mode or in TreeList mode. You should prefer a pixmap with size 32x32 pixels.

Returns:
  The empty page or 0 if the face is not TreeList, IconList or Tabbed.

Definition at line 244 of file kjanuswidget.cpp.

Referenced by KDialogBase::addPage().

QFrame * KJanusWidget::addPage | ( | const QStringList & | items,
|  | const QString & | header = QString::null,
|  | const QPixmap & | pixmap = QPixmap()
| ) | `[virtual]`

This is like addPage just above, with the difference that the first element is a list of strings.

These strings are used to form a path of folders down to the given page. The initial elements are names for the folders, while the last element is the name of the page. Note: This does yet only work for the TreeList face. Later this may be added for the IconList face too. In other faces than the TreeList, all the strings except the last one is ignored. Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Definition at line 224 of file kjanuswidget.cpp.

QVBox * KJanusWidget::addVBoxPage | ( | const QString & | item,
|  | const QString & | header = QString::null,
|  | const QPixmap & | pixmap = QPixmap()
| ) | `[virtual]`

Add a new page when the class is used in TreeList, IconList or Tabbed mode.

The returned widget is empty and you must add your widgets as children to this widget. The returned widget is a QVBox so it contains a QVBoxLayout layout that lines up the child widgets are vertically.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Parameters:

  item | String used in the list or Tab item.
  header | A longer string used in TreeList and IconList mode to describe the contents of a page. If empty, the item string will be used instead.
  pixmap | Used in IconList mode or in TreeList mode. You should prefer a pixmap with size 32x32 pixels.

Returns:
  The empty page or 0 if the face is not TreeList, IconList or Tabbed.

Definition at line 271 of file kjanuswidget.cpp.

Referenced by KDialogBase::addVBoxPage().

QVBox * KJanusWidget::addVBoxPage | ( | const QStringList & | items,
|  | const QString & | header = QString::null,
|  | const QPixmap & | pixmap = QPixmap()
| ) | `[virtual]`

This is like addVBoxPage just above, with the difference that the first element is a list of strings.

These strings are used to form a path of folders down to the given page. The initial elements are names for the folders, while the last element is the name of the page. Note: This does yet only work for the TreeList face. Later this may be added for the IconList face too. In other faces than the TreeList, all the strings except the last one is ignored.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Definition at line 254 of file kjanuswidget.cpp.

References KDialog::spacingHint().

QHBox * KJanusWidget::addHBoxPage | ( | const QString & | itemName,
|  | const QString & | header = QString::null,
|  | const QPixmap & | pixmap = QPixmap()
| ) | `[virtual]`

Add a new page when the class is used in TreeList, IconList or Tabbed mode.

The returned widget is empty and you must add your widgets as children to this widget. The returned widget is a QHBox so it contains a QHBoxLayout layout that lines up the child widgets are horizontally.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Parameters:

  item | String used in the list or Tab item.
  header | A longer string used in TreeList and IconList mode to describe the contents of a page. If empty, the item string will be used instead.
  pixmap | Used in IconList mode or in TreeList mode. You should prefer a pixmap with size 32x32 pixels.

Returns:
  The empty page or 0 if the face is not TreeList, IconList or Tabbed.

Definition at line 296 of file kjanuswidget.cpp.

Referenced by KDialogBase::addHBoxPage().

QHBox * KJanusWidget::addHBoxPage | ( | const QStringList & | items,
|  | const QString & | header = QString::null,
|  | const QPixmap & | pixmap = QPixmap()
| ) | `[virtual]`

This is like addHBoxPage just above, with the difference that the first element is a list of strings.

These strings are used to form a path of folders down to the given page. The initial elements are names for the folders, while the last element is the name of the page. Note: This does yet only work for the TreeList face. Later this may be added for the IconList face too. In other faces than the TreeList, all the strings except the last one is ignored.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Definition at line 280 of file kjanuswidget.cpp.

References QHBox::setSpacing(), and KDialog::spacingHint().

QGrid * KJanusWidget::addGridPage | ( | int | n,
|  | Orientation | dir,
|  | const QString & | itemName,
|  | const QString & | header = QString::null,
|  | const QPixmap & | pixmap = QPixmap()
| ) | `[virtual]`

Add a new page when the class is used in either TreeList or Tabbed mode.

The returned widget is empty and you must add your widgets as children to this widget. The returned widget is a QGrid so it contains a QGridLayout layout that places up the child widgets in a grid.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Parameters:

  n | Specifies the number of columns if 'dir' is QGrid::Horizontal or the number of rows if 'dir' is QGrid::Vertical.
  dir | Can be QGrid::Horizontal or QGrid::Vertical.
  item | String used in the list or Tab item.
  header | A longer string used in TreeList and IconList mode to describe the contents of a page. If empty, the item string will be used instead.
  pixmap | Used in IconList mode or in TreeList mode. You should prefer a pixmap with size 32x32 pixels.

Returns:
  The empty page or 0 if the face is not TreeList, IconList or Tabbed.

Definition at line 324 of file kjanuswidget.cpp.

Referenced by KDialogBase::addGridPage().

QGrid * KJanusWidget::addGridPage | ( | int | n,
|  | Orientation | dir,
|  | const QStringList & | items,
|  | const QString & | header = QString::null,
|  | const QPixmap & | pixmap = QPixmap()
| ) | `[virtual]`

This is like addGridPage just above, with the difference that the first element is a list of strings.

These strings are used to form a path of folders down to the given page. The initial elements are names for the folders, while the last element is the name of the page. Note: This does yet only work for the TreeList face. Later this may be added for the IconList face too. In other faces than the TreeList, all the strings except the last one is ignored.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Definition at line 305 of file kjanuswidget.cpp.

References QGrid::setSpacing(), and KDialog::spacingHint().

void KJanusWidget::removePage | ( | QWidget * | page | ) |

Removes a page created with addPage, addVBoxPage, addHBoxPage or addGridPage. If the page has already been deleted or has already been removed, nothing happens. The widget itself is not deleted.

Parameters:

  page | The widget returned by addPage , addVBoxPage , addHBoxPage or addGridPage .

Definition at line 1044 of file kjanuswidget.cpp.

References QMap< QListBoxItem *, QWidget * >::begin(), QMap< QListViewItem *, QWidget * >::begin(), QMap< QListBoxItem *, QWidget * >::end(), QMap< QListViewItem *, QWidget * >::end(), QMap< QListBoxItem *, QWidget * >::remove(), QMap< QListViewItem *, QWidget * >::remove(), QTabWidget::removePage(), and QWidgetStack::removeWidget().

int KJanusWidget::pageIndex | ( | QWidget * | widget | ) | const`[virtual]`

Returns the index of a page created with addPage , addVBoxPage , addHBoxPage or addGridPage .

You can can compare this index with the value returned from activePageIndex if you need to do some page specific actions in your code.

The returned index will never change so you can safely use this function once and save the value.

Parameters:

  widget | The widget returned by addPage , addVBoxPage , addHBoxPage or addGridPage .

Returns:
  The index or -1 if the face is not Tabbed, TreeList or IconList

Definition at line 655 of file kjanuswidget.cpp.

References QWidget::parentWidget().

Referenced by KDialogBase::pageIndex().

bool KJanusWidget::setSwallowedWidget | ( | QWidget * | widget | ) | `[virtual]`

Defines the widget to be swallowed.

This method can be used several times. Only the latest defined widget will be shown.

Parameters:

  widget | The widget to be swallowed. If 0, then an empty rectangle is displayed.

Definition at line 486 of file kjanuswidget.cpp.

References QGridLayout::addWidget(), QObject::isWidgetType(), QWidget::layout(), QWidget::minimumSize(), QWidget::reparent(), and QWidget::setMinimumSize().

Referenced by KJanusWidget(), and KDialogBase::setMainWidget().

void KJanusWidget::setTreeListAutoResize | ( | bool | state | ) | `[virtual]`

This function has only effect in TreeList mode.

Defines how the tree list is resized when the widget is resized horizontally. By default the tree list keeps its width when the widget becomes wider.

Parameters:

  state | The resize mode. If false (default) the TreeList keeps its current width when the widget becomes wider.

Definition at line 805 of file kjanuswidget.cpp.

References QSplitter::setResizeMode().

Referenced by KDialogBase::setTreeListAutoResize().

void KJanusWidget::setShowIconsInTreeList | ( | bool | state | ) | `[virtual]`

This function has only effect in TreeList mode.

This tells the widgets whether the icons given in the addPage, addVBoxPage, addHBoxPage, or addGridPage methods should be shown in the TreeList.

Note: This method must be called before calling any of the methods which add icons to the page.

Parameters:

  state | If true the icons are shown.

Definition at line 825 of file kjanuswidget.cpp.

Referenced by KDialogBase::setShowIconsInTreeList().

void KJanusWidget::setRootIsDecorated | ( | bool | state | ) | `[virtual]`

This function has only effect in TreeList mode.

This tells the widgets whether the root should be decorated. For details see QListView::setRootIsDecorated

Parameters:

  state | Root will be decorated if true.

Definition at line 830 of file kjanuswidget.cpp.

References QListView::setRootIsDecorated().

Referenced by KDialogBase::setRootIsDecorated().

void KJanusWidget::setIconListAllVisible | ( | bool | state | ) | `[virtual]`

This function has only effect in IconList mode.

Defines how the icon list widget is displayed. By default it is the widgets in the pages that decide the minimum height of the toplevel widget. A vertical scrollbar can be used in the icon list area.

Parameters:

  state | The visibility mode. If true, the minimum height is adjusted so that every icon in the list is visible at the same time. The vertical scrollbar will never be visible.

Definition at line 817 of file kjanuswidget.cpp.

Referenced by KDialogBase::setIconListAllVisible().

void KJanusWidget::setFolderIcon | ( | const QStringList & | path,
|  | const QPixmap & | pixmap
| ) | `[virtual]`

Sets the icon used in TreeList Mode for the given path.

Parameters:

  path | The path for which this icon should be shown.
  pixmap | The icon used.

Definition at line 478 of file kjanuswidget.cpp.

References QMap< QString, QPixmap >::insert(), QStringList::join(), and KStdAccel::key().

Referenced by KDialogBase::setFolderIcon().

void KJanusWidget::setFocus | ( |  | ) | `[virtual, slot]`

| Give the keyboard input focus to the widget. Reimplemented from QWidget. Definition at line 714 of file kjanuswidget.cpp. References QWidget::setFocus().

void KJanusWidget::showEvent | ( | QShowEvent * |  | ) | `[protected, virtual]`

| Reimplemented to handle the splitter width when the the face is TreeList. Reimplemented from QWidget. Definition at line 838 of file kjanuswidget.cpp. References QSplitter::setResizeMode().

bool KJanusWidget::eventFilter | ( | QObject * | o,
|  | QEvent * | e
| ) | `[protected, virtual]`

This function is used internally when in IconList mode.

If you reimplement this class a make your own event filter, make sure to call this function from your filter.

Parameters:

  o | Object that has received an event.
  e | The event.

Definition at line 853 of file kjanuswidget.cpp.

References QEvent::type().

The documentation for this class was generated from the following files:

- kjanuswidget.h
- kjanuswidget.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:01:30 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001